#! /bin/bash

#use set -x to debug with no execution of commands use set -xn
#set -x
#----------------------------------------------------------------------------
#vars
sambalocation="/etc/samba/smb.conf"
sambabackup="/etc/samba/smb.conf.bak"
#functions
#----------------------------------------------------------------------------
program_exit(){
cd "/home/$USER"
echo "--------------------------"
echo "program will exit"
$SHELL
exit
}
userprofiles(){
#userprofiles standaard------------------------------------------------------
echo "add following lines to the end of the smb.conf file"
echo "change the parrameters as desired , close te file and restart samba"
echo "first we will make a backup of your conf file"
timestamp=$(date +%s)
bufile="/etc/samba/smb.conf"$timestamp".bak"
sudo cp $sambalocation $bufile
echo "backup file created in /etc/samba/"
read -p "give the profilename :" profilename
dirpath=$(zenity --file-selection --directory --title="share directory")
read -p "give the username (muliple user seperated with , and space) or groupname with @ :" shareusername
sleep 1
sudo xdg-open $sambalocation
echo "
[$profilename]
path = $dirpath
comment = $profilename
browseable = yes
writable = yes
guest ok = no
valid users=$shareusername, @sambashare
force group = sambashare
write mode = 775
directory mode = 775
"
}
#----------------------------------------------------------------------------
check_install(){
if (dpkg -s samba | grep "install ok installed"); then
echo "----------------------------------------------------------------------------"
echo "samba is installed and ready to use"
echo "checking if backup config file is made"
if [ -f $sambabackup ]; then
echo "backupfile already exists = ok"
else
sudo cp $sambalocation "/etc/samba/smb.conf.bak"
echo "backup file created in /etc/samba/"
xdg-open /etc/samba/
fi
else
echo "----------------------------------------------------------------------------"
echo "you need to install samba trough the repositories in order to run this tool"
program_exit
fi

}
#----------------------------------------------------------------------------
addsmbuser(){
setusername
checkunixuser
if (getent passwd {1000..1500} | grep $usname); then
    if (sudo pdbedit -L | grep -w $usname) ; then
    echo "samba user $usname already exist"
    else 
    echo "samba user $usname doen't exist and will be created"
    sudo smbpasswd -a "$usname"
    echo "$usname  = added to sambashares"
    restartsamba
    fi
    
else
echo "smb user can't be created because he's not a unix user'"
fi
listusers
}
#----------------------------------------------------------------------------
removesmbuser(){
listusers
echo "wich user you want to delete"
setusername
if (sudo pdbedit -L | grep -w $usname) ; then
echo "samba user $usname exist and will be deleted"
sudo smbpasswd -x "$usname"
echo $usname " = removed from smb"
restartsamba
read -p "do you want to delete also the unix account $usname (y/n)" answer2
reply2="y"
    if test $answer1 = $reply1 ; then
    checkuserid=$(id -u $usname)
        if test $checkuserid = "1000"; then
        echo "this user is the admin user and can't be deleted as unix user"
        else
        sudo userdel $usname
        echo $usname " = removed from the system"
        fi
    else
    echo "the unix user $usname is not removed"
    fi
else 
echo "samba user $usname doen't exist"
fi
listusers
}
#----------------------------------------------------------------------------
listusers(){
echo "-------------------------"
echo "regular unix users"
sudo getent passwd {1000..1500}
echo "-------------------------"
echo "smb users"
sudo pdbedit -L
echo "-------------------------"
echo "user active in group sambashare"
sudo getent group sambashare
echo "-------------------------"
}
#----------------------------------------------------------------------------
openconffile(){
echo "to use smb with windows computers you need to add some lines to the global section of the config file"
echo "you can change WORKGROUP to the group you want"
echo "the netbiosname is max 15 characters and show up on the network of other computers"
echo "replace : 'workgroup = WORKGROUP'  with following lines and save the file and close it "
echo "restart samba after closing the file to implement the changed values"
echo "------------------------------------------------------------------------------------------------------"
echo "
workgroup = WORKGROUP
server min protocol = SMB2_10
client min protocol = SMB2
client max protocol = SMB3
netbios name = PCNAME
"
timestamp=$(date +%s)
bufile="/etc/samba/smb.conf"$timestamp".bak"
sudo cp $sambalocation $bufile
echo "backup file created in /etc/samba/"
sleep 1
sudo xdg-open $sambalocation
}
#----------------------------------------------------------------------------
makebackupfile(){
timestamp=$(date +%s)
bufile="/etc/samba/smb.conf"$timestamp".bak"
sudo cp $sambalocation $bufile
echo "backup file created in /etc/samba/"
sudo xdg-open /etc/samba/

}
#----------------------------------------------------------------------------
setusername(){
echo " specify the username"
read -p "username ?  " usname
echo "username = " $usname
}

#check and make unix users-------------------------------------------------------------
checkunixuser(){
if (getent passwd {1000..1500} | grep $usname); then
echo "unix user $usname already exist"
else
echo "unix user $usname doens't exist"
echo "to add a user to the samba share, you need to make a unix user"
echo "this program can made a unix user whitout a user home folder just for samba share acces"
echo "if you need a new user with the home folder you need to make it with the system"
echo "this is not provided in this scope"
read -p "do you want to make a new unix user (y/n)" answer1
reply1="y"
    if test $answer1 = $reply1 ; then
	    echo "making new unix user and give it the sambashare group"
        sudo useradd -M $usname
        if (groups $usname | grep -w sambashare) ; then
        echo "$usname belongs already to sambashare"
        else 
        echo "$usname doen't belong to group sambashare and will be added to the group"
        sudo usermod -aG sambashare $usname
     groups $usname
     fi
     else
     echo "no new unix user will be made"
     fi
fi
}
#restart samba services----------------------------------------------------
restartsamba(){
echo " restart samba services"
sudo systemctl restart smbd
sudo systemctl restart nmbd 
}
#----------------------------------------------------------------------------
choisepattern(){
clear
echo "-------------------------------------------"
echo " make your choise ?
1= add smb user  
2= remove smb user 
3= list smb and unix users  
4= change smb config file --WARNING BE CAREFULL--  
5= restart samba
6= show smb conf file READ ONLY
7= open samba folder
8= find your ip adress for connection with windows computer
9= make backupfile
10= making special userprofiles
e= exit program"
read -p "choise ? " keuze
echo $keuze
case "$keuze" in
1) echo "add new samba user"
   addsmbuser
   ;;
2) echo "remove samba user"
   removesmbuser
   ;;
3) echo " list smb and unix users"
   listusers
   ;;
4) echo " CHANGE config file"
   openconffile
   ;;
5) restartsamba
   echo " samba service restarted"
   ;;
6) echo " show samba conf file"
   clear
   cat $sambalocation
   #testparm
   ;;
7) echo " open smb folder"
   sudo xdg-open /etc/samba/
   ;;
8) echo " ip adress of this computer for connection with windows computers"
   ip addr | grep inet
   ;;
9) makebackupfile
   ;;
10) echo "making special user profiles"
    userprofiles
   ;;
e) echo " exit program"
   program_exit
   ;;
esac
vraagexit
}
#----------------------------------------------------------------------------
main(){
echo "------------------------------------------------"
#choisepattern
vraagexit
}
#----------------------------------------------------------------------------
vraagexit(){
read -p "do you wish to continue (y/n)  " keuze2
echo $keuze2
if test $keuze2 = "y" ; then
choisepattern
else
program_exit
fi
}
#----------------------------------------------------------------------------
#program start from here
#info
echo "information----------------------------------------------"
echo "this program is tested for Linux mint 21.3 and 22"
echo "program for configure samba shares"
echo "this program is free for use and modifications"
echo "we are not responsible for any form of system damage"
echo "copyright @2024 sitecsolutions"
echo "---------------------------------------------------------"
check_install
main
$SHELL
